// StrCalc - patial: others

// #partial MCEvaler

//##########################################################
//        Zvf̕ό`
//##########################################################
//------------------------------------------------
// Zvf (val, vt)  EӒl|Ԓl WJ
// 
// @ EӒlWJ => result: not Ӓl
// @ @ԒlWJ => result: not ʎq
//------------------------------------------------
// EӒlWJ
#modfunc evaler_ExpandValueAsRVal var it, var vt
	evaler_ExpandValueImpl thismod, it, vt, false, miEnv
	return
	
// ԒlWJ
#modfunc evaler_ExpandValueAsResult var it, var vt
	evaler_ExpandValueImpl thismod, it, vt, true, miEnv
	return
	
// Core
#modfunc evaler_ExpandValueImpl var it, var vt, int bResult, int env,  local iVar, local tmp, local _env
	_env = miEnv : miEnv = env
;	dbgout "EӒlWJ: " + dbgpair(it, vt)
	switch ( vt )
		// ϐ
		case Valtype_Var:
			it = var_GetValue( it, vt )
			
			if ( bResult ) { swbreak }
			go_case vt
			
		// ʎq
		case Valtype_Ident:
			evaler_ExpandIdent thismod, it, vt
			go_case vt
			
		// ȗl
		case Valtype_Mark:
			if ( it == TkType_Omission ) {
				it = assocNull
				vt = Valtype_Assoc
			}
			swbreak
			
		// Az
		case Valtype_Assoc:
			evaler_ExpandAssoc thismod, it, vt, bResult, false
			swbreak
			
		// vpeB
		case Valtype_Propaty:
			if ( bResult ) { swbreak }
			if ( pair_getLhs(it) != assocNull ) {		// this != null => get sEӒl𓾂
				iVar = assoc_Find( pair_getRhs(it), "get" )
				if or( iVar < 0, not EnumRange_Valtype_Callable(var_GetType(iVar)) ) { PutErrorMsg "get ̂ȂvpeB͉EӒlQƂłȂB" }
				
				// getter sA̕Ԓl𓾂
				switch ( var_GetType(iVar) )
					case Valtype_Assoc:
						tmp = Valtype_Assoc			// rhs_vt ̑
						it = evaler_ProcOpBin_AssocByName( thismod, var_Get(iVar), vt, OpFuncName("Call"), pair_getLhs(it), tmp )
						swbreak
						
					case Valtype_Block:
						it = evaler_ProcBlock( thismod, pair_getLhs(it), var_Get(iVar), vt )
						swbreak
						
					case Valtype_Func:
				;	case Valtype_Method:
						it = evaler_CallFunc( thismod, vt, pair_getLhs(it), var_Get(iVar), assocNull )
						swbreak
				swend
				go_case vt
			}
			swbreak
			
	;	case Valtype_RefArg:		// Qƈ (EӒlWJȂ)
	;	case Valtype_*:
		default:
			// do nothing
	swend
	miEnv = _env
	
	return
	
//------------------------------------------------
// ʎqWJ
//
// @prm bDefinition: `Ȃ猻ɒ` ( var, := ̍ӂ̂ )
// @prm bNoChain:    ݂̂猟 ( ݂ var ̂ )
//------------------------------------------------
#modfunc evaler_ExpandIdent var it, var vt,  int bDefinition, int bNoChain
	ExpandIdent it, vt, miEnv, bDefinition, bNoChain
	return
	
#deffunc ExpandIdent@MCEvaler var it, var vt, int iEnv,  int bDefinition, int bNoChain,  local tmp, local iVar
	
	// ϐƂČ
	iVar = env_FindVar( iEnv, it, bNoChain )
	if ( iVar >= 0 ) {
		it = iVar
		vt = Valtype_Var
		
		// vpeB
		if ( var_GetType(iVar) == Valtype_Propaty ) {
			it = var_Get(iVar)		// propaty
			vt = Valtype_Propaty
			
			if ( pair_getLhs(it) == assocNull ) {		//  => Đ; (tɁAς݂Ȃ瑩Ȃ)
				tmp = env_lastFoundAssoc(), pair_getRhs(it)		// ϐꂽAz, vpeBAz
				it = new_pair( tmp(0), tmp(1) )
			}
		}
		return
	}
	
	// ` => 
	if ( bDefinition ) {
		assoc_DefVar env_GetAssoc(iEnv), it, assocNull, Valtype_Assoc
		it = stat
		vt = Valtype_Var
		
	} else {
		it = new_block_ByValue( it, Valtype_Ident, iEnv )
		vt = Valtype_Block
	}
	
	return
	
//------------------------------------------------
// Az̓WJ
//------------------------------------------------
#modfunc evaler_ExpandAssoc var it, var vt, int bResult, int bArglist,  local self, local tmp, local iVar
	if ( it == assocNull ) { return }
	
	self = it
	switch ( assoc_GetPrototypeAssoc(self) )		// .prototype  assoc idx
	
		// vector, tuple : ϐʎqꍇAEӒlWJ
		case stt_assoc_vector:
		case stt_assoc_tuple:
			if ( not vector_IsExpanded(self) ) {		// WJ̏ꍇ
				if ( not bResult ) { vector_BeExpanded self }			// WJς݃tO𗧂Ă (ԒlWJł͗ĂȂ)
				repeat vector_Size( self )
					iVar = vector_Get(self, cnt)
					
					tmp  = iVar
					vt   = Valtype_Var									// ! ϐ vt ϐɎg
					
					if and( bArglist, var_GetType(tmp) == Valtype_RefArg ) {	// QƈWJ
						pair_getvBoth var_Get(tmp), tmp, vt
						
						if ( vt == Valtype_Var ) { vector_ReplaceVar self, cnt, tmp : continue }
						
					} else {
						evaler_ExpandValueImpl thismod, tmp, vt, bResult, assoc_GetEnv(self)	// WJ
					}
					
					var_Setv iVar, tmp, vt				// đ
				loop
			}
			swbreak
			
		// pair : ʎq (ӂʎqł) ł\ (Eӂ͏ɉEӒlWJς)
		case stt_assoc_pair:
			iVar = assoc_Find(it, "lhs")
			if ( var_GetType(iVar) == Valtype_Ident ) {
				tmp = iVar
				vt  = Valtype_Var									// ! ϐ vt ϐɎg
				evaler_ExpandValueImpl thismod, tmp, vt, bResult, assoc_GetEnv(self)	// WJ
				
				var_Setv iVar, tmp, vt					// đ
			}
			swbreak
	swend
	
	vt = Valtype_Assoc
	return
	
//------------------------------------------------
// ӒlWJ
//------------------------------------------------
#modfunc evaler_ExpandValueAsLVal@MCEvaler var it, var vt
	switch ( vt )
		// ӒlƂėLȌ^
		case Valtype_Var:
		case Valtype_Block:
	;	case Valtype_Assoc:
		case Valtype_Propaty:
		case Valtype_RefArg:	// Qƈ
			swbreak
			
		// ʎq
		case Valtype_Ident:
			evaler_ExpandIdent thismod, it, vt
			return
			
	;	case Valtype_*:
		default:
			PutError Error_NeedLeftValue
			// do nothing
	swend
	
	return
	
//##########################################################
//        X^bN̒lo
//##########################################################
//------------------------------------------------
// pop as ** (impl)
// 
// @ X^bN炻̂܂܎oB
//------------------------------------------------
#modcfunc evaler_PopAsImpl@MCEvaler var resVt,  local result
	result = Stack_pop( mStkCalc(0) )
	resVt  = Stack_pop( mStkCalc(1) )
	return result
	
//------------------------------------------------
// pop as Ӓl(LVal)
//------------------------------------------------
#modcfunc evaler_PopAsLVal@MCEvaler var resVt,  local result, local val, local val_vt
	
	val    = Stack_pop( mStkCalc(0) )
	val_vt = Stack_pop( mStkCalc(1) )
	
	evaler_ExpandValueAsLVal thismod, val, val_vt		// ӒlWJ
	
	resVt = val_vt
	return val
	
//------------------------------------------------
// pop as EӒl(RVal) or ʎq(Ident)
//------------------------------------------------
#modcfunc evaler_PopAsRValOrIdent@MCEvaler var resVt,  local result
	
	result = Stack_pop( mStkCalc(0) )
	resVt  = Stack_pop( mStkCalc(1) )
	
	if ( resVt != Valtype_Ident ) {						// ident Ȃ炻̂܂ܕԂ
		evaler_ExpandValueAsRVal thismod, result, resVt	// EӒlƂēWJ
	}
	
	return result
	
//------------------------------------------------
// pop as EӒl(RVal)
//------------------------------------------------
#modcfunc evaler_PopAsRVal@MCEvaler var resVt,  local result
	
	result = Stack_pop( mStkCalc(0) )
	resVt  = Stack_pop( mStkCalc(1) )
	
	evaler_ExpandValueAsRVal thismod, result, resVt		// EӒlƂēWJ
	
	return result
	
//------------------------------------------------
// pop as (̌^: RVal)
// 
// @ G[`FbNށB
//------------------------------------------------
#modcfunc evaler_PopAsSpecificValtype@MCEvaler var resVt, int valtype,  local result
	result = evaler_PopAsRVal( thismod, resVt )
	if ( resVt != valtype ) { resVt = Valtype_Error : PutErrorNeed( valtype ) }
	return result
	
//------------------------------------------------
// pop as Ԓl
// 
// @ ʎq  ϐÂݓWJ
//------------------------------------------------
#modcfunc evaler_PopAsResult@MCEvaler var resVt,  local result
	result = Stack_pop( mStkCalc(0) )
	resVt  = Stack_pop( mStkCalc(1) )
	
	evaler_ExpandValueAsResult thismod, result, resVt	// ԒlƂēWJ
	
	return result
	
//------------------------------------------------
// pop (֐̈)
// 
// @ Xg list gpB
//------------------------------------------------
/*
#deffunc PopFuncArglist@MCEvaler array stkCalc, array arglist, int iEnv,  \
	local argc, local nxtArg, local nxtArg_vt
	
	list_new arglist(0)			// (value)
	list_new arglist(1)			// Valtype_*
	
	repeat
		nxtArg    = Stack_pop( stkCalc(0) )
		nxtArg_vt = Stack_pop( stkCalc(1) )
		
		if ( nxtArg_vt == Valtype_Mark && nxtArg == TkType_ArgL ) {		// I
			break
		}
		
		dbgout "func: arg << (type " + nxtArg_vt + "): " + nxtArg
		
		list_add arglist(0), nxtArg
		list_add arglist(1), nxtArg_vt
		argc ++
	loop
	
	// tɂȂĂ̂Ŕ]
	if ( argc > 0 ) {
		list_reverse arglist(0)
		list_reverse arglist(1)
	}
	
	return argc
	//*/
	
// XgEӒlWJ
#modfunc evaler_ExpandArglist int arglist,  local tmp, local tmp_vt
	dbgout "expand arglist: " + DecodeValue_Vector(arglist)
	tmp    = arglist
	tmp_vt = Valtype_Assoc
	evaler_ExpandAssoc thismod, tmp, tmp_vt, false, true	// XgƂĉEӒlWJ => RefArg WJ
	return
	
// Xg̎ʎqWJ
#modfunc ExpandArglistOnlyIdent array arglist,  local iVar, local tmp, local tmp_vt, local iEnv
	iEnv = vector_Getenv(arglist)
	
	repeat vector_Size(arglist)
		iVar = vector_Get(arglist, cnt)
		tmp_vt = var_GetType( iVar )
		
		if ( tmp_vt == Valtype_Ident ) {			// ʎq̂
			tmp = var_Get(iVar)
			
			ExpandIdent tmp, tmp_vt
			
			var_Set iVar, tmp, tmp_vt
		}
	loop
	
	return
	
//------------------------------------------------
// pop (z񃊃e)
// 
// @ WJԂŕԂB
// @	 ȂǂɓWJ͂
// @prm bArglist: XgƂĂ̎擾
//------------------------------------------------
#defcfunc PopArrayLiteral@MCEvaler array stkCalc, int iEnv, int bArglist,  \
	local vec, local nxtArg, local nxtArg_vt
	
	vec = new_vector( iEnv )
	
	repeat
		nxtArg    = Stack_pop( stkCalc(0) )
		nxtArg_vt = Stack_pop( stkCalc(1) )
		
		if ( nxtArg_vt == Valtype_Mark && nxtArg == TkType_ArrayL ) {	// I (I͊ʂɈ˂炸)
			break
			
		} elsif ( not bArglist && IsOmission(nxtArg, nxtArg_vt) ) {
			nxtArg    = assocNull
			nxtArg_vt = Valtype_Assoc
		}
		
		dbgout which(bArglist, "arglist", "array-literal") + "  " + nxtArg + " <" + EnumString_Valtype(nxtArg_vt) + ">"
		
		vector_PushBack vec, nxtArg, nxtArg_vt
	loop
	
	vector_Reverse vec		// tɐς܂邽
	
	return vec
	
//------------------------------------------------
// pop (le)
// 
// @ WJԂŕԂB
// @	 ȂǂɓWJ͂
// @ Ō̗vf omission ȂAB
// @	tɐς܂̂ŁA(cnt == 0) ̂ƂŌ̗vfB
//------------------------------------------------
#defcfunc PopTupleLiteral@MCEvaler array stkCalc, int iEnv, int cntArgs,  \
	local result, local nxtArg, local nxtArg_vt
	
	result = new_tuple( iEnv )
	
	repeat cntArgs
		nxtArg    = Stack_pop( stkCalc(0) )
		nxtArg_vt = Stack_pop( stkCalc(1) )
		
		if ( cnt == 0 && (nxtArg == TkType_Omission && nxtArg_vt == Valtype_Mark) ) { continue }
		
		vector_PushBack result, nxtArg, nxtArg_vt
	loop
	
	vector_Reverse result	// tɐς܂邽
	return result
	
