// ini ǗW[NX

#ifndef IG_MODULECLASS_INI_AS
#define IG_MODULECLASS_INI_AS

#module MCIni mfname

#uselib "kernel32.dll"
#func   WritePrivateProfileString "WritePrivateProfileStringA" sptr,sptr,sptr,sptr
#func   GetPrivateProfileString   "GetPrivateProfileStringA"   sptr,sptr,sptr,int,int,sptr
#cfunc  GetPrivateProfileInt      "GetPrivateProfileIntA"      sptr,sptr,int,sptr

#define true  1
#define false 0
#define null  0

#enum global IniValtype_None = 0
#enum global IniValtype_Indeterminate = 0
#enum global IniValtype_String = 2			// vartype ̒lƈv
#enum global IniValtype_Double
#enum global IniValtype_Int
#enum global IniValtype_MAX

#define ctype IniKeyArrayIdx(%1, %2) ((%1) + "#" + (%2))
#define ctype IniKeyMember(%1, %2) ((%1) + "." + (%2))

// @static
	stt_stmp = ""

//**********************************************************
//        \zE
//**********************************************************
#define global ini_new(%1, %2) newmod %1, MCIni@, %2
#modinit str fname
	mfname = fname
	
	exist fname
	if ( strsize < 0 ) { bsave fname, mfname, 0 }	// t@CōĂ
	return
	
#define global ini_delete(%1) delmod %1
	
//**********************************************************
//        f[^ǂݍ
//**********************************************************
#define global ctype ini_get(%1, %2, %3, %4 = "", %5 = 0) ini_get_( %1, %2, %3, str(%4), %5 )

//------------------------------------------------
//  ( sttm-form )
// 
// @prm (this)
// @prm dst : 󂯎ϐ
// @prm sec : ZNV
// @prm key : L[
// @prm def : 蕶 ( L[݂ȂƂ )
// @prm max : ő啶
//------------------------------------------------
#define global ini_getsv(%1, %2, %3, %4, %5 = "", %6 = 1200) ini_getsv_ %1, %2, %3, %4, %5, %6
#modfunc ini_getsv_ var dst, str sec, str key, str def, int maxlen
	if ( maxlen > 1200 ) { memexpand stt_stmp, maxlen + 1 }
	
	GetPrivateProfileString sec, key, def, varptr(stt_stmp), maxlen, varptr(mfname)
	
	dst = stt_stmp
	return
	
//------------------------------------------------
//  ( func-form )
// 
// @prm (ini_getsv: dst ȊO)
//------------------------------------------------
#define global ctype ini_gets(%1, %2, %3, %4 = "", %5 = 1200) ini_gets_(%1, %2, %3, %4, %5)
#modcfunc ini_gets_ str sec, str key, str def, int maxlen
	if ( maxlen > 1200 ) { memexpand stt_stmp, maxlen + 1 }
	
	ini_getsv thismod, stt_stmp, sec, key, def, maxlen
	return stt_stmp
	
//------------------------------------------------
//  ( func-form )
//------------------------------------------------
#modcfunc ini_getd str sec, str key, double def
	GetPrivateProfileString sec, key, str(def), varptr(stt_stmp), 32, varptr(mfname)
	return double(stt_stmp)
	
//------------------------------------------------
//  ( func-form )
//------------------------------------------------
#define global ctype ini_geti(%1, %2, %3, %4 = 0) ini_geti_( %1, %2, %3, %4 )
#modcfunc ini_geti_ str sec, str key, int def
	return GetPrivateProfileInt( sec, key, def, varptr(mfname) )
	
//------------------------------------------------
// z
// 
// @prm (this)
// @prm dst : 󂯎ϐ (zƂď)
// @prm sec : ZNV
// @prm key : L[ (z)
//------------------------------------------------
#modfunc ini_getArray array dst, str sec, str key,  local len, local valtype
	len     = ini_geti( thismod, sec, IniKeyMember(key, "$length"),  0 )
	valtype = ini_geti( thismod, sec, IniKeyMember(key, "$valtype"), IniValtype_Indeterminate )
	
	if ( valtype == IniValtype_Indeterminate ) {
		valtype = ValtypeByString( ini_gets( thismod, sec, IniKeyArrayIdx(key, 0) ) )	// [0] ̌^Ŕ肷
	}
	
	dimtype dst, valtype, len
	
	repeat len
		dst(cnt) = ini_get( thismod, sec, IniKeyArrayIdx(key, cnt), , valtype )
	loop
	
	return
	
//------------------------------------------------
// any ( func-form )
//------------------------------------------------
#modcfunc ini_get_ str sec, str key, str def, int valtype_,  local valtype
	ini_getsv thismod, stt_stmp, sec, key, def
	if ( valtype_ ) { valtype = valtype_ } else { valtype = ValtypeByString(stt_stmp) }
	
	switch ( valtype )
		case IniValtype_String: return       (stt_stmp)
		case IniValtype_Double: return double(stt_stmp)
		case IniValtype_Int:    return    int(stt_stmp)
	swend
	
//**********************************************************
//        f[^
//**********************************************************
//------------------------------------------------
// 
//------------------------------------------------
#modfunc ini_puts str sec, str key, str data
	WritePrivateProfileString sec, key, "\"" + data + "\"", varptr(mfname)
	return
	
//------------------------------------------------
//  (L16)
//------------------------------------------------
#modfunc ini_putd str sec, str key, double data
	WritePrivateProfileString sec, key, strf("%.16e", data), varptr(mfname)
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#modfunc ini_puti str sec, str key, int data
	WritePrivateProfileString sec, key, str(data), varptr(mfname)
	return
	
//------------------------------------------------
// any
//------------------------------------------------
#define global ini_put(%1, %2, %3, %4, %5 = 0) stt_tmp@MCIni = (%4) : ini_putv %1, %2, %3, stt_tmp@MCIni, %5
#modfunc ini_putv str sec, str key, var data, int valtype_,  local valtype
	if ( valtype_ ) { valtype = valtype_ } else { valtype = ValtypeByString(str(data)) }
	switch ( valtype )
		case IniValtype_String: ini_puts thismod, sec, key,       (data) : swbreak
		case IniValtype_Double: ini_putd thismod, sec, key, double(data) : swbreak
		case IniValtype_Int:    ini_puti thismod, sec, key,    int(data) : swbreak
	swend
	return
	
//**********************************************************
//        
//**********************************************************
//------------------------------------------------
// 
// 
// @prm (this)
// @prm dst : 󂯎ϐ (z)
// @prm[sec : ZNV]
//------------------------------------------------
#define global ini_enumSection(%1, %2, %3 = 0) ini_enum_impl %1, %2, "", %3
#define global ini_enumKey(%1, %2, %3, %4 = 0) ini_enum_impl %1, %2, %3, %4

#modfunc ini_enum_impl array dst, str sec_, int maxlen_,  local maxlen, local pSec, local sec
	maxlen = limit(maxlen_, 1024, 0xFFFF)
	
	if ( sec_ == "" ) { pSec = null } else { sec = sec_ : pSec = varptr(sec) }
	
*LReTry:
	if ( maxlen > 1200 ) { memexpand stt_stmp, maxlen + 1 }
	
	GetPrivateProfileString pSec, null, null, varptr(stt_stmp), maxlen, varptr(mfname)
	
	if ( maxlen <= 0 && (stat == maxlen - 2) ) {
		maxlen *= 2
		goto *LReTry
	}
	
	SplitByNull dst, stt_stmp, stat			// z
	return
	
// cnv: '\0' ؂蕶 -> z
#deffunc SplitByNull@MCIni array dst, var buf, int maxsize,  local idx
	idx = 0
	sdim dst
	repeat
		getstr dst(cnt), buf, idx, , maxsize
	;	logmes dst(cnt)
		idx += strsize + 1
		if ( peek(buf, idx) == 0 ) { break }		// '\0' 2A͏I[tO
	loop
	return
	
#ifdef _DEBUG
// ׂẴZNṼL[񋓂fobOo͂
 #modfunc ini_dbglog  local seclist, local sec, local keylist, local key, local stmp
	logmes "\n(ini_dbglog): @" + mfname
	
	sdim seclist
	sdim keylist
	sdim stmp
	
	ini_enumSection thismod, seclist			// ZNV
	
	foreach seclist : sec = seclist(cnt)
		logmes strf("[%s]", sec)
		
		ini_enumKey thismod, keylist, sec		// L[
		foreach keylist : key = keylist(cnt)
			ini_getsv thismod, stmp, sec, key, , 512			// Œ 512 - 1 ƂB
			logmes ("\t" + key + " = \"" + stmp + "\"")
		loop
		
	loop
	return
#else
 #define global ini_dbglog :
#endif
	
	
//**********************************************************
//        ̑̑
//**********************************************************
//------------------------------------------------
// L[̗L
// 
// @ GetPrivateProfileString  l("__"), nSize(2) ^ƂA
// @	L[݂ΕԒl 1 or 0AȂ 2 ƂȂB
//------------------------------------------------
#modcfunc ini_existsKey str sec, str key
	GetPrivateProfileString sec, key, "__", varptr(stt_stmp), 2, varptr(mfname)
	return ( stat < 2 )
;	return ( false == ( ini_geti( thismod, sec, key, 0 ) == 0 && ini_geti( thismod, sec, key, 1 ) == 1 ) )
	
//------------------------------------------------
// ZNV
//------------------------------------------------
#modfunc ini_removeSection str sec
	WritePrivateProfileString sec, null, null, varptr(mfname)
	return
	
//------------------------------------------------
// L[
//------------------------------------------------
#modfunc ini_removeKey str sec, str key
	WritePrivateProfileString sec, key, null, varptr(mfname)
	return
	
//**********************************************************
//        ̑
//**********************************************************
//------------------------------------------------
// ^𔻒肷 (from )
// 
// @ 0x* Ȃǂɂ͖Ή
//------------------------------------------------
#defcfunc ValtypeByString@MCIni str data
	if ( data == int(data) ) { return IniValtype_Int }
	if ( double(data) != 0 ) {
		if ( IsDoubleImpl(data) ) { return IniValtype_Double }
	}
	return IniValtype_String
	
#defcfunc IsDoubleImpl@MCIni str data_, local data
	data = data_
	return ( instr(data, , ".") >= 0 || instr(data, , "e") >= 0 )
	
#global

	sdim stt_stmp@MCIni, 1200 + 1
	
//##############################################################################
//                TvEXNvg
//##############################################################################
#if 0

	ini_new cfg, "C:/appdata.ini"	// J ini t@CpXŎw肵܂BȂ쐬܂B
//	( strsize = Jinit@C̃TCY ;  => Ȃ̂ō )
	
	mes ini_geti( cfg, "appdata", "x" )
	ini_dbglog cfg
;	ini_delete cfg
	stop
	
#endif

/***

t@X

INIɊւ
	EZNVAL[At@CpX́ApAt@xbg̑啶Eʂ܂B
	EL[ĺA擪іɂ󔒂͖܂ (s)B
		AL[l̑Ŝ "" ŊƁA̓̋󔒂͈ێ܂ (L[ " " ܂݂܂)B
		ex: { x = 3 } <=> (key: 'x', value: '3')
		ex: { " x " = " string " } <=> (key: '" x "', value: ' string ')
	El 0x... ́A16iƂĈ܂B
		A0... ƂĂ8iƂ@\͂܂B
	EsRg̓Z~R ; łBio[TC # vXbV // ͗LȋLłB
		܂AZNVłL[łȂꏊ͈ӖȂ킯łB
	Egq .ini  .cfg ʓIłB
	
A
	Eini_new self, "t@CpX"
	
	ini t@CJ܂BȂ̃t@C܂B
	pXɂ̓t@Cł͂ȂA΃pX΃pXw肵Ă (F"./cfg.ini", "D:/Cfg/prjx.ini", etc)B
	
	Eini_delete self
	
	ini t@C܂BK{ł͂܂B
	t@C폜킯ł͂肹B
	

	Eini_puts self, "sec", "key", "value"
	
	ZNV "sec" ̃L[ "key" ̒lA value ɐݒ肵܂B
	
	Eini_puti self, "sec", "key", value
	Eini_putv self, "sec", "key", value
	
	ZNV "sec" ̃L[ "key" ̒lAvalue ̕\Lɐݒ肵܂B
	value ̌^͖₢܂񂪁AKƂď܂܂B
	
ǂݍ
	Eini_getsv self, dst, "sec", "key", "default", maxlen
	
	ZNV "sec" ̃L[ "key" ̒lAƂĕϐ dst Ɋi[܂B
	( e int łA^̂܂܊i[܂B )
	maxlen ́Aǂݍޕ̍ő̒łBʏ 1200 [byte] łAȏオKv
	ꍇ͏ȗɎw肵ĂB
	w肵L[݂Ȃꍇ́A"default"̒lԂ܂Bȗ "" (󕶎)łB
	
	Eini_geti( self, "sec", "key", default )
	
	ZNV "sec" ̃L[ "key" ̒lAlƂēǂݏoĕԂ܂Bstr  0 Ԃ܂B
	w肵L[݂ȂꍇAdefault ̒lԂ܂Bȗ 0 łB
	
	Eini_gets( self, "sec", "key", "default", maxlen )
	
	ini_getsv ̊֐`łBmaxlen ́Aȗ 1200 ɂȂ܂B
	
INIf[^̍폜
	Eini_removeSection self, "sec"
	
	ZNV "sec" 폜܂Bɖ߂܂B
	
	Eini_removeKey self, "sec", "key"
	
	ZNV "sec" ̃L[ "key" 폜܂Bɖ߂܂B
	
̑
	Eini_existsKey( self, "sec", "key" )
	
	ZNV "sec" ̃L[ "key" ݂邩ǂB݂Ȃ^Ԃ܂B
	@ l̂ȂL[ ("key=" ) ́A݂Ȃ̂ƂĈ܂B
	
***/
#endif
