// fobOxW[

#ifndef IG_MODULE_DEBUG_AS
#define IG_MODULE_DEBUG_AS

#ifdef _DEBUG

//##############################################################################
//                fobO
//##############################################################################
#include "Mo/mod_replace.as"

#undef logmes

#module mod_debug

#define true  1
#define false 0

#define global __HERE__ (__FILE__ + " (#" + __LINE__ + ")")

// @static
	ctx = 0		// HSPCTX N[

//------------------------------------------------
// ⏕}N
//------------------------------------------------
#ifndef __UserDefHeader__
 #define global ctype dbgstr(%1) ({"%1 = "} + (%1))
 #define global ctype dbgpair(%1,%2) ({"(%1,%2) = ("} + (%1) + ", " + (%2) + ")")
 #define global ctype dbghex(%1) strf({"%1 = 0x%%08X"}, (%1))
 #define global ctype dbgchar(%1) strf({"%1 = '%%c'"}, (%1))
 #define global ctype dbgcode(%1,%2) %1
#endif

#define global ctype dbgchk_s(%1, %2) dbgchk_s_impl(%1, %2, {"%1"}, {"%2"}, __HERE__)
#define global ctype dbgchk_d(%1, %2) dbgchk_d_impl(%1, %2, {"%1"}, {"%2"}, __HERE__)
#define global ctype dbgchk_i(%1, %2) dbgchk_i_impl(%1, %2, {"%1"}, {"%2"}, __HERE__)

//------------------------------------------------
// Ԍvp
//------------------------------------------------
#uselib "winmm.dll"
#cfunc global _nowtime "timeGetTime"

//----------------------------------------------------------
// W[
//----------------------------------------------------------
#deffunc mod_debug_init
	mref ctx, 68
	dupptr exinfo, varptr( ctx(12) ), 188
	
;	sdim stt_logindex
	return
	
//----------------------------------------------------------
// w肵ϐ̌^^Cv̌^擾
//----------------------------------------------------------
#defcfunc vtname int type,  local name, local hspvar
	if ( type <= 0 ) { return "" }
	
	prm = type
	
	dupptr hspvar, callfunc( prm, exinfo(25), 1 ), 20	// \bhȗ
	if ( hspvar(3) == 0 ) {
		sdim name				// 󕶎Ԃ
	} else {
		dupptr name, hspvar(3), 1, 2
	}
	return name
	
//##########################################################
//                Oo͊֌W
//##########################################################
// o̓^Cv
#enum global LogMode_Normal = 0			// Plain-Text
#enum global LogMode_Formal				// t
#enum global LogMode_Max

//------------------------------------------------
// Oo͂̏
//------------------------------------------------
#deffunc _init_logmes int mode
	stt_logpath  = dir_mydoc + "/hsplog.log"
	stt_logindex = 0
	stt_logmode  = mode						// `I
	stt_bLogmes  = true						// ʏo ( logmes@ ) 邩
	sdim   stt_logstr,  1024
	bsave  stt_logpath, stt_logstr, 0		// ㏑đÕf[^폜
	return
	
//------------------------------------------------
// Ot@Cɏo
//------------------------------------------------
#define global logmes(%1 = "", %2 = __FILE__, %3 = __LINE__) _logmes str(%1), %2, %3
#deffunc _logmes str _sLog,  str fname, int iLine
	
	// ʏo
	if ( stt_bLogmes ) {
		logmes@hsp _sLog
	}
	
	switch ( stt_logmode )
		case LogMode_Normal:
			stt_logstr = _sLog + "\n"
			swbreak
			
		case LogMode_Formal:
			sLog    = _sLog
			StrReplace sLog, "\n", "\n\t\t"		// s  s{^u ɂ
			
			stt_logstr = strf("#%4d [%s]\n\t\t%s\n\n", fname, iLine, sLog)
			swbreak
			
	swend
	_len = strlen(stt_logstr)
	bsave stt_logpath, stt_logstr, _len, stt_logindex
	
	stt_logindex += _len
	return
	
//------------------------------------------------
// ϐ̓eOɏo
//------------------------------------------------
#define global logvar(%1, %2 = __FILE__, %3 = __LINE__) _logvar %1, "%1", %2, %3
#deffunc _logvar var v, str varname,  str fname, int iLine
	stmp = varname
	stmp = strtrim(stmp)		// Ő󔒂
	
	switch ( vartype(v) )
		// 
		case vartype("str"):
			if ( instr(v, , "\n") >= 0 ) {
				logmes strf("%s = {\"%s\"}", stmp, v)	// s̏ꍇ
			} else {
				logmes strf("%s = \"%s\"", stmp, v)		// Ps̏ꍇ
			}
			swbreak
			
		// 
		case vartype("double"):
			logmes strf("%s\t= %f", stmp, v), fname, iLine
			swbreak
			
		// 
		case vartype("int"):
			logmes strf("%s\t= %i ( 0x%08X )", stmp, v, v), fname, iLine
			swbreak
			
		// ̑
		default:
			logmes strf("%s is %s type.", stmp, vtname(vartype(v)))
			swbreak
			
	swend
	return
	
//------------------------------------------------
// logmes ̏o͌`ύX
//------------------------------------------------
#deffunc logmode int mode
	stt_logmode = mode
	logmes "\n\LogMode has changed.\n\n", "system", 0
	return
	
//------------------------------------------------
// ʏo͂邩ǂ
//------------------------------------------------
#deffunc log_echo int bLogmes
	stt_bLogmes = bLogmes
	return
	
//----------------------------------------------------------
// AT[g (֐)
//----------------------------------------------------------
#define ctype FTM_dbgchk_impl(%1 = class) \
	if ( b == false ) { logmes "dbgchk: %1( " + x + ": " + code_value + " ) don't fullfil " + code_condition + ")\t@" + _there } \
	return x
	
#defcfunc dbgchk_s_impl str x, int b, str code_value, str code_condition, str _there
	FTM_dbgchk_impl(str)
#defcfunc dbgchk_d_impl double x, int b, str code_value, str code_condition, str _there
	FTM_dbgchk_impl(double)
#defcfunc dbgchk_i_impl int x, int b, str code_value, str code_condition, str _there
	FTM_dbgchk_impl(int)
	
#undef FTM_dbgchk_impl
	
#global

	mod_debug_init
	_init_logmes LogMode_Normal

//##############################################################################
//                [X
//##############################################################################
#else

#define global ctype _nowtime 0

#define global __HERE__ ""
#define global ctype vtname(%1) ""
#define global logmode(%1=0) :
#define global logvar(%1) :

#ifndef __UserDefHeader__
 #define global ctype dbgstr(%1) ""
 #define global ctype dbgpair(%1,%2) ""
 #define global ctype dbghex(%1) ""
 #define global ctype dbgchar(%1) ""
 #define global ctype dbgcode(%1,%2) %2
#endif

#define global ctype dbgchk_s(%1, %2) (%1)
#define global ctype dbgchk_d(%1, %2) (%1)
#define global ctype dbgchk_i(%1, %2) (%1)

#endif

#endif
