// ėp񑀍샂W[

#ifndef IG_STRING_UTILITY_AS
#define IG_STRING_UTILITY_AS

/**+
 * strutil
 * String utility module
 * @ author Ue-dai
 * @date 2008/09/29
 * @ver 1.0.0
 * @type ߊgW[
 * @group 񑀍֐
 */

#include "mod_replace.as"

#module strutil

// ߁E֐ Ԃ̕ϐ̏Փ˂͋CɂȂB
// @ʂ̊֐́AՓ˂ĂȂꍇAĂяoĂ͂ȂB

#include "ctype.as"

#define true  1
#define false 0

// ֐

// p}N
#define MPROC_DoUntil(%1=cntvar,%2=cond,%3=break,%4) repeat : if (%2) { break } %4 : if ( %1 < 0 ) { %3 } : loop

// p1 ̕ϐAp2 藧܂ E }N
#define MPROC_IncUntil(%1=cntvar,%2=cond,%3=break) MPROC_DoUntil %1,%2,%3,%1 ++
#define MPROC_DecUntil(%1=cntvar,%2=cond,%3=break) MPROC_DoUntil %1,%2,%3,%1 --

//##################################################################################################
//        񑀍n
//##################################################################################################
/**
 * }
 * p1 ̓rɕ}܂B
 * @prm p1 = var	: ^ϐ
 * @prm p2 = int(0)	: ItZbg
 * @prm p3 = str	: }镶
 * @prm p4 = int(-1): p1 ̒Bȗ\B
 * @prm p5 = int(-1): p3 ̒Bȗ\B
 * @return = int	: ̒
 */
#define global StrInsert(%1,%2=0,%3,%4=-1,%5=-1) _StrInsert %1,%2,%3,%4,%5
#deffunc _StrInsert var p1, int p2, str p3, int p4, int p5
	
	if ( p4 < 0 ) { len(0) = strlen(p1) } else { len(0) = p4 }
	if ( p5 < 0 ) { len(1) = strlen(p3) } else { len(1) = p5 }
	if ( len(1) == 0 ) {           return len(0) }
	if ( len(0) == 0 ) { p1 = p3 : return len(1) }
	
	sdim stmp, len(1) + 1
	stmp = p3
	
	memexpand p1,       len(0) + len(1) + 1				// p1 L ( BufferOverflow 邽 )
	memcpy    p1,   p1, len(0) - p2, len(1) + p2, p2	// ŜɓAp1 ̑OɋԂ
	memcpy    p1, stmp, len(1)     ,          p2,  0	// oԂɃRs[
	poke      p1,       len(0) + len(1), 0				// Ō NULL Ŏ~߂
	
	return ( len(0) + len(1) )
	
/**
 * 폜
 * p1 AwoCg̕폜܂B
 * @prm p1 = var	: ^ϐ
 * @prm p2 = int(0)	: ItZbg
 * @prm p3 = int	: 폜钷
 * @prm p4 = int(-1): p1 ̒Bȗ\B
 * @return = int	: ̒
 */
#define global StrDelete(%1,%2=0,%3,%4=-1) _StrDelete %1,%2,%3,%4
#deffunc _StrDelete var p1, int offset, int size, int p4
	
	if ( p4   < 0 ) { len = strlen(p1) } else { len = p4 }
	if ( size < 0 ) { return len }
	
	iSpace = len - (offset + size)					// ɏo󔒂̑傫
	
	memcpy p1, p1, iSpace, offset, offset + size	// ㏑Rs[
	memset p1,  0,   size, offset + iSpace			// ɏo󔒂𖄂߂
	return (len - size)
	
/**
 * 񂩂ÕXy[X^uAs
 * ^ϐ p1 ÕXy[Xނ폜܂B
 * 
 * stripstr ƂOłgpł܂B
 * @+ Blank ́AXy[XA^uAswB
 * @+ 2 oCg 2 oCgڂXy[Xނ̕R[hɂȂ邱Ƃ͂肦Ȃ
 * @prm p1 = var	: ^ϐ
 * @prm p2 = int(-1): p1 ̒Bȗ\B
 * @return = int	:  p1 ̒
 */
#define global StripBlanks(%1,%2=-1) _StripBlanks %1,%2
#deffunc _StripBlanks var p1, int p2
	
	if ( p2 < 0 ) { len = strlen(p1) } else { len = p2 }
	
	// ̃uN
	p = len				// `FbN镶CfbNX
	repeat len
		p --
		c = peek(p1, p)
		if ( IsBlank(c) == false ) {
			p ++
			break	// 󔒂łȂΏI
		}
	loop
	
	memset p1, 0, len - p, p	// NULL ɂ
	len  = p					// CfbNX́Au擪 ` O̕v̒̕Ɠ
	
	// 擪̃uN
	for p, 0, len
		c = peek(p1, p)
		if ( IsBlank(c) == false ) { _break }
	next
	
	StrDelete p1, 0, p, len	// Ő󔒂폜
	return stat				// 폜̕񒷂Ԃ
	
#define global stripstr StripBlanks

/**
 * 񂩂Öp
 * ^ϐ p1 ÖpAʏ͈폜܂B
 * ''xxx'' ̂悤ȕ́A'xxx' ɂȂ܂B(폜̂)
 * p3 ^(0ȊO)̏ꍇAÖpׂč폜܂B
 * 
 * ̖߂́AÖp̐ĂĂCɂ܂B
 * 
 * @prm p1 = var	: ^ϐ
 * @prm p2 = int(-1): p1 ̒Bȗ\B
 * @prm p3 = bool(0): pS폜邩
 * @return = int	:  p1 ̒
 */
#deffunc StripQuote var p1, int p2, int p3
	if ( p2 < 0 ) { len = strlen(p1) } else { len = p2 }
	
	if ( len <= 0 ) { return 0 }
	
	// ̈p
	repeat ( p3 == 0 ) - ( p3 != 0 )	// p3 ^Ȃ疳[v
		c = peek(p1, len - 1)
		if ( IsQuote(c) ) { len -- : poke p1, len, 0 } else { break }
	loop
	
	// 擪̈p
	repeat ( p3 == 0 ) - ( p3 != 0 )	// p3 ^Ȃ疳[v
		c = peek(p1)
		if ( IsQuote(c) ) { StrDelete p1, 0, 1, len : len = stat } else { break }
	loop
	return len
	
/**
 * 𔽕
 * w肵񐔁A܂B
 * 0ȉȂA󕶎񂪕Ԃ܂B
 * @prm p1 = str	: Ώۂ̕
 * @prm p2 = int	: 
 * @prm p3 = int	: p1 ̒( ȗ\ )
 * @return = str	: p1 * p2
 */
#define global ctype strmul(%1="",%2=0,%3=-1) strmul_(%1,%2,%3)
#defcfunc strmul_ str p1, int p2, int p3
	if ( p2 <= 0 ) { return "" }
	if ( p2 == 1 ) { return p1 }
	
//*
	if ( p2 & 1 ) {
		return strmul_( p1 + p1, p2 / 2, p3 ) + p1
	} else {
		return strmul_( p1 + p1, p2 / 2, p3 )
	}
/*/
	
	if ( p3 <  0 ) { len = strlen(p1) } else { len = p3 }
	
	sdim stmp, len + 1
	sdim sRet, len * p2 + 1
	stmp = p1
	
	repeat p2
		memcpy sRet, stmp, len, len * cnt
	loop
	return sRet
//*/
	
//##################################################################################################
//         擾n
//##################################################################################################
/**
 * ؂
 *  p4 Ap2  p3 炻ꂪƂ܂ł؂oAԂ܂B
 * Ȃꍇ́Ap2 ́up3 ` I[vԂ܂B
 * @prm p1 = var	: ؂󂯎ϐ
 * @prm p2 = var	: ^ϐ
 * @prm p3 = int(0)	: ItZbg
 * @prm p4 = str	: 镶
 * @prm p5 = int(-1): p2 ̒Bȗ\B
 * @prm p6 = int(-1): p4 ̒Bȗ\B
 * @return = int	: ؂̒
 */
#define global StrCut(%1,%2,%3=0,%4,%5=-1,%6=-1) _StrCut %1,%2,%3,%4,%5,%6
#deffunc _StrCut var p1, var p2, int p3, str p4, int p5, int p6
	if ( p5 < 0 ) { len(0) = strlen(p2) } else { len(0) = p5 }
	if ( p6 < 0 ) { len(1) = strlen(p4) } else { len(1) = p6 }
	
	// 
	i = instr(p2, p3, p4)
	if ( i < 0 ) {
		i = len(0) - p3		// ׂ
	}
	
	// ʂ p1 ɃRs[
	memexpand p1, i + 1			// mۂłTCY܂Ŋg
	memcpy    p1, p2, i, 0, p3	// Rs[
	poke      p1, i, 0			// NULLŏI
	return i
	
/**
 * n oCg̕擾
 *  p1 ́An byte ΂Ƃ납n܂镶Ԃ܂B
 * @prm p1 = str	: 
 * @prm p2 = int	: 炷oCg
 * @prm p3 = int(-1): p1 ̒Bȗ\
 * @return = str	: ʕ
 */
#define global ctype StrShift(%1,%2,%3=-1) _StrShift(%1,%2,%3)
#defcfunc _StrShift str p1, int nShift, int p3
	if ( p3 < 0 ) { len = strlen(p1) } else { len = p3 }
	sdim stmp, len + 1
	stmp = p1
	
	iSpace = len - nShift
	memcpy stmp, stmp, iSpace, 0, nShift
	memset stmp,    0, nShift, iSpace
	return stmp
	
/**
 * 񂩂环ʎqo
 *  p2 ̃CfbNX p3 环ʎq(PP)o܂B
 * oʎqϐ p1 Ɋi[A̒Ԃ܂B
 * 
 * 擪ɂ́ApAt@xbg _ ƑSpA
 * 񕶎ڈȍ~͔p܂B
 * 
 * scanident(p3, p1, p2) Ƃ`̃}NpӂĂ܂B
 * @prm p1 = var	: ʎq̕i[ϐ
 * @prm p2 = var	: ^ϐ
 * @prm p3 = int	: ̃CfbNX
 * @return = int	: ʎq̒(bytes)
 * 
 * @TODO : @ ɂXR[v͂ǂH
 */
#defcfunc CutIdent var p1, var p2, int offset
	if ( vartype(p1) != vartype("str") ) { sdim p1, 64 }
	
	c = peek(p2, offset)
	if ( IsIdentTop(c) == false && IsSJIS1st(c) == false ) {
		poke p1
		return 0
	}
	repeat , offset + 1 + IsSJIS1st(c)
		// 񕶎ڂ
		c = peek(p2, cnt)
		if ( IsSJIS1st(c) ) { continue (cnt + 2) }	// Sp
		if ( IsIdent(c) == false ) {
			i = cnt - offset
			break
		}
	loop
	
	// Ԓlobt@ɃRs[
	memcpy p1, p2, i, 0, offset
	poke   p1,  i, 0			// NULLI[Ŏ~߂
;	p1 = strmid(p2, offset, i)
	return i
	
#define global ctype scanident(%1,%2=0,%3) TookIdent(%3,%1,%2)

// ʎq̐擪܂Ŗ߂
#defcfunc BackToIdentTop var p1, int offset, int bIsLineSpace
	if ( offset <= 0 ) { return -1 }
	i = offset - 1
	
	// 󔒂΂( Oɂ󔒗̐擪܂ňړ )
	MPROC_DecUntil i, IsSpace2(peek(p1, i), bIsLineSpace) == false
	if ( i < 0 ) { return -1 }
;	i ++
	
	if ( IsSpace2(peek(p1, i), bIsLineSpace) ) { i -- }
	
	// ʎq΂( ʎq̐擪܂ i 𓮂 )
	MPROC_DecUntil i, IsIdent(peek(p1, i)) == false
	if ( i < 0 ) { i = 0 }
	i ++
	
	// lXLbv( 擪ƂĕsK؂Ȃ΂ )
	MPROC_IncUntil i, IsIdentTop(peek(p1, i)) || peek(p1, i) == 0
	
	return offset - i
	
/**
 * ̎ʎq擾
 * ̎w肵ItZbg̒Oɂ鎯ʎqo܂B
 * ItZbĝȂɎʎqꍇ́Ao܂B
 * 
 * s܂͕̓܂ŁAʎqłȂꍇA
 * ܂́AItZbgʒuOɁAʎqł͂ȂL
 * ꍇ́A󕶎 p1 ɕԂ܂B
 * 
 * scanidentb(p2, p3, p1, p4=0) Ƃ}Ngpł܂B
 * @prm p1 = var	: ʎq̕i[ϐ
 * @prm p2 = var	: ^ϐ
 * @prm p3 = int	: ItZbgl
 * @prm p4 = bool	: s󔒂Ƃ݂Ȃ
 * @return = int	: ʎq̒(bytes)
 */
#defcfunc CutIdentBack var p1, var p2, int offset, int bIsLineSpace
	if ( offset <= 0 ) {
		poke p1
		return 0
	}
	return CutIdent( p1, p2, offset - BackToIdentTop(p2, offset, bIsLineSpace) )
	
//##################################################################################################
//        Ԏ擾n
//##################################################################################################
/**
 * ̎wʒu󔒂ƃ^ȗ񐔂𐔂
 *  p1 ̃CfbNX p2 󔒂ƃ^ȗ񐔂𐔂܂B
 * 񐔂Ԃ܂B
 * 
 * spnspace ƂOłgpł܂B
 * @prm p1 = var		: ^ϐ
 * @prm p2 = int(0)		: ̃CfbNX
 * @prm p3 = bool(0)	: s󔒂ƌȂ
 * @return = int		: 󔒂ƃ^ȗ
 */
#defcfunc CntSpaces var p1, int p2, int bIsLineSpace
	i = p2
	while ( IsSpace(peek(p1, i)) || IsNewLine(peek(p1, i)) * (bIsLineSpace != 0) )
		i ++
	wend
	return i - p2
	
#define global spnspace CntSpaces		// ʖœo^
	
// ɋ󔒂̑Ԃ
#defcfunc CntSpacesBack var p1, int p2
	if ( p2 == 0 ) { return 0 }
	i = p2 - 1
	MPROC_DecUntil i, IsSpace(peek(p1, i)) == false
	return p2 - i - 1
	
/**
 * Q̎wʒu瓯ȇoCg𐔂
 * ^ϐ p1 ̃CfbNX p3 ƕ^ϐ p2 ̃CfbNX p4 瓯ȇoCg𐔂܂B
 * @prm p1 = var	: ^ϐ
 * @prm p2 = var	: ^ϐ
 * @prm p3 = int(0)	: p1 ̃CfbNX
 * @prm p4 = int(0)	: p3 ̃CfbNX
 * @return = int	: ȇoCg
 */
#defcfunc StrSameBytes var p1, var p2, int p3, int p4
	i = 0
	repeat
		c = peek(p1, p3 + i)
		if ( c != peek(p2, p4 + i) || c == 0 ) {
			break
		}
		i ++
	loop
	return i
	
/**
 * Q̎wʒuwoCg񂪑
 * ^ϐ p1 ̃CfbNX p4 ƕ^ϐ p2 ̃CfbNX p5 Ap3 oCgeׂ܂B
 * @prm p1 = var	: ^ϐ
 * @prm p2 = var	: ^ϐ
 * @prm p3 = int	: oCg
 * @prm p4 = int(0)	: p1 ̃CfbNX
 * @prm p5 = int(0)	: p3 ̃CfbNX
 * @return = bool	: Ȃ^
 */
#defcfunc StrCompNum var p1, var p2, int p3, int p4, int p5
	ret = 1		// ^ɐݒ
	repeat p3
		c = peek(p1, p4 + cnt)
		if ( c != peek(p2, p5 + cnt) ) {
			ret = 0
			break
		}
	loop
	return ret
	
/**
 * wʕT(jAT[`)
 * ɕ܂B
 * g͂قƂ instr() ֐ƓłA
 * instrb()֐ԂCfbNXĺAItZbgƊ֌WȂ̂
 * CĂB
 * 
 * ItZbǵAʏʂO琔܂B
 * 납̃ItZbǵA(Ŝ̒ - ÕItZbg - 1)
 * ŎZoł܂B
 * @prm p1 = var	: Ώە^ϐ
 * @prm p2 = int(0)	: ItZbg
 * @prm p3 = str	: 镶
 * @prm p4 = int(-1): p1 ̒Bȗ\
 * @prm p5 = int(-1): p3 ̒Bȗ\
 * @return = int	: ʒũCfbNXA
 * @algorithm		: Linear Search
 */
#define global ctype instrb(%1,%2=0,%3,%4=-1,%5=-1) _instrb(%1,%2,%3,%4,%5)
#defcfunc _instrb var p1, int offset, str p3, int p4, int p5
	if ( p4 < 0 ) { len(0) = strlen(p1) } else { len(0) = p4 }
	if ( p5 < 0 ) { len(1) = strlen(p3) } else { len(1) = p5 }
	
	// 납T
	sdim stmp, len(1) + 1
	stmp = p3
	i    = len(0) - offset - 1
	c    = peek(stmp)
	
	while ( i >= 0 )
		// 擪̔rō
		if ( peek(p1, i) == c ) {
			// ?
			if ( strmid(p1, i, len(1)) == stmp ) {
				return i
			}
		}
		i --
	wend
	
	// łȂ
	return -1
	
#global

//######## TvEvO ################################################
#if 0

#undef        print
#define ctype print(%1=s) mes "[%1] = ["+ (%1) +"]"

	t = "01234567890123456789012345678901234567890"
	s = "0123456789ABCDEF"
	print(t)
	print(s)
	
	StrDelete s, 2, 4
	mes "length : stat = "+ stat +", strlen = "+ strlen(s)
	print(s)
	
	stop
	
#endif

#endif

#if 0
	t = "01234567890123456789012345678901234567890"
	s = "/* */    UINT WINAPI func(argument_type) { ...; }"
	
	i = 15
	m = BackToIdentTop(s, i)
	mes m
	mes i - m
	mes CutIdentBack(v, s, i)
	mes v
#endif
