// StrCalc - CheckError

#ifndef IG_MODULE_STRCALC_CHECK_ERROR_AS
#define IG_MODULE_STRCALC_CHECK_ERROR_AS

#include "Mo/abdata/queue.as"

#module mod_StrCalc_chkerr

#include "header_inner.as"

//------------------------------------------------
// g[NG[`FbN
// 
// @ preproc ̃g[N񂩂G[o
//------------------------------------------------
#deffunc StrCalc_CheckError array inQueue,  local befType, local nowType, local nowData
	
	nowType = TkType_None
	befType = TkType_None
	
	// G[`FbN
	repeat Queue_size( inQueue(0) )
		
		// f[^XV
		befType = nowType
		nowType = Queue_peek( inQueue(0), cnt )
		nowData = Queue_peek( inQueue(1), cnt )
		
		// 򏈗
		gosub *LProcCheckError
		if ( stt_error ) { break }
		
	loop
	
	return which( stt_error == Error_None, success, failure )
	
*LProcCheckError
	//+--------------------+
	//|         l         |
	//+--------------------+
	// EO l
	if ( IsValueType(nowType) && IsBefValueType(befType) ) {
		logmes "[Error] nowType l( " + nowData + " )\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	//+--------------------+
	//|              |
	//+--------------------+
	// EO
;	} elsif ( IsBracketL(nowType) && (  ) ) {
;		logmes "[Error] nowType \nbefType == "+ befType
;		PutError Error_Syntax
		
	//+--------------------+
	//|       E       |
	//+--------------------+
	// EO 񍀉Zq or PZq::Ou or J} or 
	} elsif ( IsBracketR(nowType) && eq_or( befType, TkType_BinOp, TkType_PrefixOp, TkType_Comma, TkType_None ) ) {
		logmes "[Error] nowType E\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	//+--------------------+
	//|     񍀉Zq     |
	//+--------------------+
	// EO  or 񍀉Zq or PZq::Ou or 
	} elsif ( nowType == TkType_BinOp && (IsBracketL(befType) || eq_or(befType, TkType_BinOp, TkType_PrefixOp, TkType_None)) ) {
		logmes "[Error] nowType 񍀉Zq( " + GetName_BinOp(nowData) + " )\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	//+--------------------+
	//|  PZq::Ou  |
	//+--------------------+
	// EO l or E or PZq::u
	} elsif ( nowType == TkType_PrefixOp && IsBefValueType(befType) ) {
		logmes "[Error] nowType PZq::Ou( " + GetName_UniOp(nowData) + " )\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	//+--------------------+
	//|  PZq::u  |
	//+--------------------+
	// EO  or 񍀉Zq or PZq::Ou or 
	} elsif ( nowType == TkType_PostfixOp && ( IsBracketL(befType) || eq_or(befType, TkType_BinOp, TkType_PrefixOp, TkType_None) ) ) {
		logmes "[Error] nowType PZq::u( " + GetName_UniOp(nowData) + " )\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	//+--------------------+
	//|        I[        |
	//+--------------------+
	// EO  or 񍀉Zq or PZq::Ou
	} elsif ( nowType == TkType_None && ( IsBracketL(befType) || eq_or(befType, TkType_BinOp, TkType_PrefixOp) ) ) {
		logmes "[Error] nowType I[\nbefType == " + EnumString_TkType(befType)
		PutError Error_Syntax
		
	} else {
		// OK
	}
	
	return Error_None
	
#global

#endif
