// tnode - ؍\(1) ()

#ifndef IG_ABSTRACT_DATA_STRUCTURE_TREE_NODE_IMPL_AS
#define IG_ABSTRACT_DATA_STRUCTURE_TREE_NODE_IMPL_AS

// @ tree node (tnode)
// @ o { m[hl, qf[^, ef[^ }
// @ IɁAqf[^ tnode ˂߂Ύqm[hɁA
// @	qf[^ list, pair Ȃǂ˂߂Ε̎qm[h𓾂B
// @ <m[hl, qf[^, ef[^> ɂꂼ [0], [1], [2] Ƃ index UB

// @# ̏ł́Alist  wrapper B

#include "list.as"
#include "alg_iter.as"

//##############################################################################
//                abdata::tnode<1> (impl)
//##############################################################################
;#define global tnodeInsts st_allinsts@abdata_tnode
#define global tnodeNull  st_null@abdata_tnode

#define global TNIdx_Value  0
#define global TNIdx_Child  1
#define global TNIdx_Parent 2

//------------------------------------------------
// [i] vf
//------------------------------------------------
#define global ctype tnode_size (%1) 3	// list_size
#define global ctype tnode_empty(%1) 0	// false
#define global tnode_count  tnode_size
#define global tnode_length tnode_size

//##############################################################################
//                \zE
//##############################################################################
//------------------------------------------------
// \z
//------------------------------------------------
#module abdata_tnode

#define ctype ARG_TEMP(%1) st_temp_%1_arg@abdata_tnode

#define global tnode_new(%1, %2 = stt_zero@, %3 = stt_zero@, %4 = tnodeNull) \
	ARG_TEMP@abdata_tnode(1) = (%2) :\
	ARG_TEMP@abdata_tnode(2) = (%3) :\
	ARG_TEMP@abdata_tnode(3) = (%4) :\
	tnode_new_ %1, ARG_TEMP@abdata_tnode(1), ARG_TEMP@abdata_tnode(2), ARG_TEMP@abdata_tnode(3) ://
	
#deffunc tnode_new_ var self, var value, var child, var parent
	list_new self
	tnode_resetElemsv self, value, child, parent
	return
	
#defcfunc new_tnode var value, var child, var parent,  local newOne
	tnode_new newOne, value, child, parent
	return newOne
	
//------------------------------------------------
// 3̗vfǉ
//------------------------------------------------
#define global tnode_resetElems(%1, %2 = stt_zero@, %3 = stt_zero@, %4 = tnodeNull) \
	ARG_TEMP@abdata_tnode(1) = (%2) :\
	ARG_TEMP@abdata_tnode(2) = (%3) :\
	ARG_TEMP@abdata_tnode(3) = (%4) :\
	tnode_resetElemsv %1, ARG_TEMP@abdata_tnode(1), ARG_TEMP@abdata_tnode(2), ARG_TEMP@abdata_tnode(3) ://
	
#deffunc tnode_resetElemsv var self, var value, var child, var parent
	if ( list_empty(self) != false ) { return }
	list_insertv self, value,  TNIdx_Value
	list_insertv self, child,  TNIdx_Child
	list_insertv self, parent, TNIdx_Parent
	return
	
#global

//------------------------------------------------
// 
//------------------------------------------------
#define global tnode_delete list_delete

//##############################################################################
//                o߁E֐
//##############################################################################

//##########################################################
//        擾n
//##########################################################
//------------------------------------------------
// l̎擾 ( ߌ` )
//------------------------------------------------
#define global tnode_getv_ list_getv
;#define global tnode_popv_ list_popv

#define global tnode_getv(%1,%2)       tnode_getv_ %1, %2, TNIdx_Value
#define global tnode_getvChild(%1,%2)  tnode_getv_ %1, %2, TNIdx_Child
#define global tnode_getvParent(%1,%2) tnode_getv_ %1, %2, TNIdx_Parent

//------------------------------------------------
// l̎擾 ( ֐` )
//------------------------------------------------
#define global tnode_get_ list_get
;#define global tnode_pop_ list_pop

#define global ctype tnode_get(%1)       tnode_get_( %1, TNIdx_Value )
#define global ctype tnode_getChild(%1)  tnode_get_( %1, TNIdx_Child )
#define global ctype tnode_getParent(%1) tnode_get_( %1, TNIdx_Parent )

//------------------------------------------------
// QƉ ( ߌ` )
//------------------------------------------------
#define global tnode_clone_ list_clone

#define global tnode_clone(%1,%2)       tnode_clone_ %1, %2, TNIdx_Value
#define global tnode_cloneChild(%1,%2)  tnode_clone_ %1, %2, TNIdx_Child
#define global tnode_cloneParent(%1,%2) tnode_clone_ %1, %2, TNIdx_Parent

//------------------------------------------------
// QƉ ( ֐` )
//------------------------------------------------
#define global tnode_ref_ list_ref

#define global ctype tnode_ref(%1)       tnode_ref_( %1, TNIdx_Value )
#define global ctype tnode_refChild(%1)  tnode_ref_( %1, TNIdx_Child )
#define global ctype tnode_refParent(%1) tnode_ref_( %1, TNIdx_Parent )

//------------------------------------------------
// 擪E̒l̎o
// 
// @ get  >> const ȑ
// @ pop  >> vf͎菜
//------------------------------------------------

//------------------------------------------------
// ^̎擾 ( ֐` )
//------------------------------------------------
#define global tnode_vartype_ list_vartype

#define global ctype tnode_vartype(%1)       tnode_vartype_( %1, TNIdx_Value )
#define global ctype tnode_vartypeChild(%1)  tnode_vartype_( %1, TNIdx_Child )
#define global ctype tnode_vartypeParent(%1) tnode_vartype_( %1, TNIdx_Parent )

//##########################################################
//        n
//##########################################################
//------------------------------------------------
// f[^u
//------------------------------------------------
#define global tnode_set_  list_set
#define global tnode_setv_ list_setv

#define global tnode_set(%1,%2)       tnode_set_ %1, %2, TNIdx_Value
#define global tnode_setChild(%1,%2)  tnode_set_ %1, %2, TNIdx_Child
#define global tnode_setParent(%1,%2) tnode_set_ %1, %2, TNIdx_Parent

#define global tnode_setv(%1,%2)       tnode_setv_ %1, %2, TNIdx_Value
#define global tnode_setvChild(%1,%2)  tnode_setv_ %1, %2, TNIdx_Child
#define global tnode_setvParent(%1,%2) tnode_setv_ %1, %2, TNIdx_Parent

//------------------------------------------------
// }, [ւ̒ǉ, , 
//------------------------------------------------
// @ Ȃ

//##########################################################
//        Rei
//##########################################################
//------------------------------------------------
// [i] Rei
//------------------------------------------------
#define global tnode_clear(%1,%2) list_clear %1 : tnode_resetElems %1
#define global tnode_chain(%1,%2) logmes {"[Error!] tnode_chain %1,%2 ͂ł܂I"}
#define global tnode_copy     list_copy
#define global tnode_exchange list_exchange

//##########################################################
//        q
//##########################################################
//------------------------------------------------
// [i] q
//------------------------------------------------
#define global tnode_iterInit list_iterInit
#define global tnode_iterNext list_iterNext

//##########################################################
//        Gn
//##########################################################
//------------------------------------------------
// ͈̓`FbN
//------------------------------------------------
#define global ctype tnode_isValid(%1,%2) ( 0 <= (%2) && (%2) < tnode_size(%1) )

//##########################################################
//        ÓIo߁E֐
//##########################################################

//##########################################################
//        fobOp
//##########################################################
#module

#ifdef _DEBUG
//-------- fobO --------

//------------------------------------------------
// m[hċAIɏo͂
//------------------------------------------------
;#define global tnode_dbglog list_dbglog
#deffunc tnode_dbglog int self, int nest,  local thisId, local it, local stmp
	sdim stmp, nest * 2 + 512
	
	if ( nest > 0 ) {
		repeat nest - 1
			stmp += "|  "
		loop
	}
	
	if ( tnode_isRoot(thisId) == false ) {
		stmp += "|-- "
	}
	
	logmes stmp + TNode_get(self)
	
	IterateBegin self, tnode, it
		tnode_dbglog it, nest + 1
	IterateEnd
	
	return
	
#else
//-------- fobO --------

#define TNode_dbglog(%1,%2) :

#endif

#global

//##########################################################
//        qm[h::gL@
//##########################################################
// @ tnb_* : 񕪖 (child is a pair)
// @ tnx_* : w (child is a list)

//------------------------------------------------
// qm[h̒ǉ ( ߌ` )
//------------------------------------------------
#ifdef pair_new
 #define global ctype tnb_addChd(%1, %2 = stt_zero@, %3 = stt_zero@, %4 = stt_zero@) \
	VAR_TEMP@abdata_tnode = (%2)				/* m[hl */:\
	pair_new VAR_TEMP2@abdata_tnode, %3, %4		/* qf[^ɂȂ pair 쐬 */:\
	tnode_new_ %1, VAR_TEMP@abdata_node, VAR_TEMP2@abdata_tnode, %1 ://
#endif

#ifdef list_new
 #define global tnx_addChd(%1,%2 = tnodeNull) list_add tnChd(%1), %2
#endif

//------------------------------------------------
// qm[h̎擾 ( ֐` )
//------------------------------------------------
#define global tnChd tnode_getChild

#ifdef pair_new
 #define global ctype tnbChd(%1,%2=0) pair_get   ( tnode_getChild(%1), %2 )
 #define global ctype tnbChdLhs(%1)   pair_getLhs( tnode_getChild(%1) )
 #define global ctype tnbChdRhs(%1)   pair_getRhs( tnode_getChild(%1) )
#endif

#ifdef list_new
 #define global ctype tnxChd(%1,%2=0) list_get( tnode_getChild(%1), %2 )
#endif

//------------------------------------------------
// qm[h̐
//------------------------------------------------
#ifdef pair_new
 #define global ctype tnbSize(%1) pair_size( tnode_getChild(%1) )
 #define global tnbCount  tnbSize
 #define global tnbLength tnbLength
#endif

#ifdef list_new
 #define global ctype tnxSize(%1) list_size( tnode_getChild(%1) )
 #define global tnxCount  tnxSize
 #define global tnxLength tnxLength
#endif

	tnodeNull = 0

//##############################################################################
//                TvEXNvg
//##############################################################################
#if 0

	tnode_new root, "e", new_list() ;, tnodeNull (eȂ)
	
	for i, 0, 3
		
		tnode_new   chd, tnode_get(root) + " - q(" + i + ")", new_list(), root
		tnx_addChd root, chd
		
		repeat 5
		;	chd = list_get( tnode_getChild(root), i )
			
			tnode_new  grandChd, tnode_get(chd) + " - (" + cnt + ")", new_list(), chd
			tnx_addChd chd, grandChd
		loop
		
	next
	
	for i, 0, tnxSize(root)
	;	chd = list_get( tnode_getChild(root), i )
		repeat tnxSize( tnxChd(root, i) )
			mes tnode_get( tnxChd( tnxChd(root, i), cnt ) )
		loop
	next
	
	pos 300, 10
	tnode_dbglog root
	stop
	/*
	tnode_new  root2, "root2"
	tnx_addChd root2, tr
;	tnode_copy root2, tr
	TNode_dbglog root2
	
	TNode_addSubTree tr, tr2
	TNode_dbglog tr
	
	logmes ""
	assert
	TNode_addSubTree tr, tr2
	TNode_dbglog tr
	
	stop
	//*/
#endif

#endif
